//Multidisplay
//work_designer2k2_03

/*
ToDo:
- (5) Throttle Calib
- (5) RPM Calib (there should be a real method, not just a factor...)
- (4) Setup Screen
- (2) Include a VDO Screen!
- (5) Battery Meter
- (3) Make the Bignum Screen flexible for all Values
- Reserv Anain and a PWM Out for Wastegate controlling...
- (1) Change the MCP3208 readin to get the chip select from the IO Chip, done 
- (1) Change tge Typ K reading for the selection to work together with the MCP3208 Chip select !!  be aware read_adc has some debug on the led\u00b4s going on!!!
*/

#include <EEPROM.h>            //for Settings / Max Value storage
#include <LCD4Bit.h>           //to output to the LCD
//#include <AFSoftSerial.h>      //The Serial Lib  24150
#include <avr/pgmspace.h>      //for PROGMEN 
#include <Wire.h>              //to get the I2C working.

//----------------------------------------------------------------------------------------------------
//Max Values:
#define MaxAGT 1200            //Maximum AGT
#define MaxOP 8                //Maximum Oilpressure
//----------------------------------------------------------------------------------------------------

//Options:

#define RPMDebug 0             //Little Frequency Generator
#define FreeMem 0              //Outputs how much free RAM is

#define InitTime 2000          //How long the Init screen will be shown 
#define RPMShiftLight 1        //Shiftlight?
//--------------------------------------

// Shiftlight Config:

#define RPMShiftLow 6000             //Shiftlight half brightness
#define RPMLowBright 40
#define RPMShiftHigh 6500            //Shiftlight full brightness
#define RPMHighBright 255
#define RPMNoBright 0                //Shiftlight normal brightness

//--------------------------------------

#define ButtonHold 1000         //ms to trigger a Hold (Every Xms a hold is triggered)
#define ScreenSaveDelay 10000	//ms after what it will save the Screen

#define FlashTime 100            //ms the interval when a Limit is exceeded, the LCD will flash with this interval)
#define FlashETime 5000          //how long the flash is shown at a minimum

//--------------------------------------
//Pin Config:

//#define SELPIN 10               //Selection Pin (MCP3208)
//#define SELPIN2 17              //Selection Pin (MCP3208_2)
#define DATAOUT 17              //MOSI 
#define DATAIN 12               //MISO 
#define SPICLOCK 13             //Clock 

// The Sensors: (On the MD03 Print, see the Layout for the KLX Connectors)

#define BoostPin 1             //(KL7-2) Currently supports the Motorola 250kpa Sensor
#define Boost2Pin 2            //(KL7-3) Currently supports the Motorola 250kpa Sensor

#define VDOT1Pin 3             //(KL6) T1 VDO Temperature Pin
#define VDOT2Pin 4             //(KL5) T2 VDO Temperature Pin
#define VDOT3Pin 5             //(KL4) T3 VDO Temperature Pin
#define VDOP1Pin 6             //(KL3) P1 VD0 Pressure Pin
#define VDOP2Pin 7             //(KL2) P1 VD0 Pressure Pin
#define VDOP3Pin 8             //(KL1) P1 VD0 Pressure Pin

#define LambdaPin 11           //(KL9-4) Narrow Band Lambda Sensor Input
#define ThrottlePin 12         //(KL9-3) 0-5V Signal from the trothle signal
#define RPMPin 13              //(KL9-2) needs a small Circuit to converts the RPM Signal into Analog Voltages
#define LMMPin 14              //(KL9-1)Signal from the LMM


#define CaseTempPin 15         //The LM35 Signal.
#define AGTPin 16              //Input from the Mux

#define BatteryPin 0           //The Signal from the voltage divider (Analog Pin on the Arduino!)
#define LCDBrightPin 5		     //The Pin for the Brightness of the LCD, it will be PWM.
#define RPMShiftlightPin 3           //where is the Shiftlight connected

//--------------------------------------
//Others:

#define LambdaMin 100            //Calibration for Lambda
#define LambdaMax 1100
#define LambdaLowerLimit 3
#define LambdaUpperLimit 15

#define ThrottleMin 620            //Calibration for Throttle
#define ThrottleMax 3530

#define RPMfactor 2.34              //Calibration for RPM (its 2.34!)
#define RPMsmooth 5                 //how many readings will be taken for the smoothing (5 is quick and smooth, 10 would be supersmooth but its getting slow)
#define RPMmax 3400                 //its about 8k

#define tempTypKReadings 28         //how many entrys are in the Lookup Table
#define NumTypK 1                   //how many TypK`s are attached (enter Number -1)
#define MaxTypK 1170                //over that will be seen as Open.

#define expander B0100001       // Address with 2 address pins grounded. (from the PCF8574)
#define expander2 B0100000      // Address with three address pins grounded. (from the PCF8574)

#define debugRPM 10

#include "WProgram.h"
void setup();
void loop();
void CGRAM_BigFont2();
void CGRAM_BigFont4();
void printOneNumber2(uint8_t digit, byte leftAdjust, int LineOffset);
void printOneNumber4(uint8_t digit, byte leftAdjust);
void bigNum (unsigned long t, int LineOffset, byte leftAdjust, int d);
void bigNum4 (unsigned long t, byte leftAdjust, int d);
void bigNum24(int Value,int LineOffset);
void blanks3();
char* format(unsigned long num);
void ButtonAHold();
void ButtonAPressed();
void ButtonBHold();
void ButtonBPressed();
void ButtonCheck();
void printfloat(float all , int decimals);
void lcdShowIntro(int delayValue);
int read_adc(int channel);
void EEPROMWriteDouble(int p_address, long p_value);
long EEPROMReadDouble(int p_address);
void LcdUploadUdef5x8(int character, int *data);
void CGRAM_Dot();
void CGRAM_Bar();
void CGRAM_Intro();
void CGRAM_Intro2();
void DrawBar(int Digits, int Value);
void AnaConversion();
void Shiftlight();
void SerialPrint();
void HeaderPrint();
void ChangeSerOut();
void CalibrateLD();
int GetTypKTemp(unsigned int microVolts);
int GetVDOTemp(int ADWreading);
int GetVDOPressure(int ADWreading);
void FetchTypK();
void CGRAM_VertBar();
void DrawVertBar(int Val, int Pos);
void ScopeMode();
uint16_t freeMem(void);
void CheckLimits();
void expanderWrite(byte _data);
byte expanderRead();
void expanderWrite2(byte _data);
byte expanderRead2();
void SaveMax(int Num);
void LCDBrightness(int Bright);
void Screen1Init();
void Screen1Work();
void Screen2Init();
void Screen2InitB();
void Print2Blanks();
void Screen2Work();
void Screen3Init();
void Screen3Work();
void Screen4Init();
void Screen4Work();
void Screen5Init();
void Screen5Work();
void Screen6Init();
void Screen6InitB();
void Screen6Work();
void Screen7Init();
void Screen7Work();
void Screen8Init();
void Screen8Work();
void Screen9Init();
void Screen9Work();
int debug = 0;

LCD4Bit lcd = LCD4Bit(4); 		        //Init the LCD (4 Lines, but that dosnt matter)
//AFSoftSerial mySerial =  AFSoftSerial(3, 2);	//Init the Serial on the Real Serial Pins

/*==============================================================================
 * GLOBAL VARIABLES
 *============================================================================*/


//Variables:
int val; 
int val1;
int val2;
int val3;
int val4;

unsigned long ScreenSave = 0;	//timestamp for the Saving

unsigned int ButtonInt = 0;     //Button state
unsigned long ButtonTime = 0;   //Button time

unsigned int Temp;

unsigned long FlashTimeU = 0;    //Time for the Screen to Toggle back
unsigned long FlashETimeU = 0;  

int AnaIn[17];          //All the Analog Values are stored in this array

int ScopeInt[20];      //needed for the Scrolling Scope

int CalAGT[NumTypK+1];  //All Typ K Values will be stored inside this array

unsigned long time;    //the current time


char buf[12];           // "-2147483648\0"

 int Screen;           //current Screen
 int SerOut;           //what serial out will be done
 int DoCal;            //its 1 for doing it, and 0 for no calibration (only RAW possible)
 int DoTypK;            // 1 makes the cal, 0 not.
 int DoCheck = 1;
 int Brightness;
 
 byte IOport2 = B11111111;          //defines what to output on the Interface print (LSB\u00b4s are the ADW)
 
 //For the Boost:
 float CalLD = 0.0;          //calibration from the Boost
 float MaxLD = 0;
 int MaxLDt=0;               //max LD for the screen
 int LDcalPoint;             //where to draw the dot from the calibration

 //Saving of the MAx Values: (0=AGT, 1=Boost, 2=RPM)
 int MaxAGTValE[4];          //maximum AGT
 float MaxLDE[4]; 
 long MaxRPME[4];            //maximum RPM
 float MaxLMME[4];         //maximum LMM
 int MaxOilE[4];             //maximum Oilpressure
  
 int RefResh;

 //convertet values:

 float CalBoost = 0.0;
 float CalRAWBoost = 0.0;
 int CalLambda = 0;
 long CalRPM = 0;
 int CalThrottle = 0;
 float CalCaseTemp = 0.0;
 float CalLMM = 0.0;
 int VDOTemp1 = 0;
 int VDOTemp2 = 0;
 int VDOTemp3 = 0;
 int VDOPres1 = 0;
 int VDOPres2 = 0;
 int VDOPres3 = 0;
 float BatVolt = 0.0;
  
 
 //RPM Smoothing:
 int RPMreadings[RPMsmooth];                // the readings from the analog input
 int RPMindex = 0;                            // the index of the current reading
 int RPMtotal = 0;                            // the running total
 int RPMaverage = 0;                          // the average

 //Lookup Table for the TypK:
 //from 0-1350\u00ef\u00bf\u00bdC in steps of 50\u00ef\u00bf\u00bdC, the list is in \u00ef\u00bf\u00bdV according to that Temp.
 const unsigned int tempTypK[] PROGMEM = 
 { 
  0,
  1922,
  3891,
  5831,
  7731,
  9645,
  11599,
  13578,
  15577,
  17590,
  19612,
  21637,
  23660,
  25674,
  27673,
  29652,
  31611,
  33547,
  35460,
  37348,
  39212,
  41050,
  42863,
  44645,
  46396,
  48112,
  49790,
  51431
};
 
 //Lookup Table for the Oilpressure: (12 Values)
 //from 0-10Bar in steps of 1Bar, the list is in 12Bit Digital Reading when supplyed with 5V and a 200Ohm Resistor in series 
 //(measuring the Voltage on the Sensor)
 //it has a increasing Resistance with the Pressure.
 const unsigned int tempVDOPressure[] PROGMEM = 
 { 
  0,
  195,
  549,
  845,
  1073,
  1271,
  1427,
  1567,
  1686,
  1794,
  1881,
  1962
};

 //Lookup Table for the VDOtemperature (22 Values) Its Calibration curve 92-027-006
 //from -30C-180C in steps of 10C, the list is in 12Bit Digital Reading when supplyed with 5V and a 200Ohm Resistor in series 
 //(measuring the Voltage on the Sensor)
 //it has a decreasing Resistance with the Temperature
 const unsigned int tempVDOTemp[] PROGMEM = 
 { 
  4053,
  4019,
  3957,
  3857,
  3706,
  3497,
  3224,
  2893,
  2527,
  2150,
  1790,
  1471,
  1200,
  968,
  782,
  632,
  515,
  422,
  348,
  287,
  238,
  199
};

//The LCD Brightness, what could be cycled through
const unsigned int LCDBrightnessD[] PROGMEM = 
{ 
  50,125,255        //Change this for other settings depending on what you like
};


/*==============================================================================
 * SETUP()
 *============================================================================*/

void setup() { 
  
  pinMode(LCDBrightPin, OUTPUT);
  
  //set pin modes 
  pinMode(DATAOUT, OUTPUT); 
  pinMode(DATAIN, INPUT); 
  pinMode(SPICLOCK, OUTPUT);  
  digitalWrite(DATAOUT,LOW); 
  digitalWrite(SPICLOCK,LOW); 
   
  Serial.begin(57600);
  
  Wire.begin();                  //Start the Wire Libary for the PCF8574
  
  expanderWrite2(IOport2); //Switch off all Devices
  
  
  //Print the Info: 
  Serial.println(" ");
  Serial.println("MultiDisplay PRE!");  
 
  //Read the Values from the EEPROM back
  Screen = EEPROM.read(100);        //what screen was last shown?
  Brightness = EEPROM.read(105);    //The Brightness from the LCD
  LDcalPoint = EEPROM.read(205); 
  CalLD = EEPROMReadDouble(200)/1000.0;      //gets the float back (thats accurate enough)
  
  lcd.init();                              //Inits the LCD
  lcdShowIntro(InitTime);                      //Shows the Into 
  
  //RPM Smoothing init:
  for (int i = 0; i < RPMsmooth; i++)
  {
   RPMreadings[i] = 0;                      // initialize all the readings to 0
  }
  
  //TypK Array init:
  for (int i = 0; i < 7; i++)
  {
   CalAGT[i] = 0;                      // initialize all the readings to 0
  }
     
  //Load the right start Screen:
   switch(Screen){
   case 0:
      //Setup the Screen:
      break;
   case 1:
      Screen1Init();
      break;
   case 2:
      Screen2Init();
      break;
   case 3:
      Screen3Init();
      break;
   case 4:
      Screen4Init();
      break;
   case 5:
      Screen5Init();
      break;
   case 6:
      Screen6Init();
      break;
   case 7:
      Screen7Init();
      break;
   case 8:
      Screen8Init();
      break;
   case 9:
      Screen9Init();
      break;
   default:
      Screen1Init();
      break;
   }
   
   
   //Init the Buttons:
   expanderWrite(B10000011);        //This may needs to be modified when a third button is attached.

   
    
}

/*==============================================================================
 * LOOP()
 *============================================================================*/

void loop() {  
    
  //Current Time:
   time = millis();

  //Read in all Analog values:
  for(int I = 1; I <=16;I++){
    AnaIn[I] = read_adc(I);
  }

  //Calibrate them:
  if(DoCal == 1)
   {
    AnaConversion();
   }
   
  //Check for Limits:
  //if(DoCheck == 1)
  // {
    CheckLimits();
  // }

  //Print it:
  SerialPrint();
  
  //Depending on what screen, it will trigger different things:  
  switch(Screen){
   case 0:
      break;
   case 1:
      Screen1Work();
      break;
   case 2:
      Screen2Work();
      break;
   case 3:
      Screen3Work();
      break;
   case 4:
      Screen4Work();
      break;
   case 5:
      Screen5Work();
      break; 
   case 6:
      Screen6Work();
      break; 
   case 7:
      Screen7Work();
      break;       
   case 8:
      Screen8Work();
      break;  
   case 9:
      Screen9Work();
      break;  
   default:
      break;
  }  


  //My own Button Check Function

  ButtonCheck();
   
  //Saves the Screen when needed:
   
  if(millis()>= ScreenSave)
  {
    //and now save it:
    EEPROM.write(100,Screen);  
    //And also prevent a double save!
    ScreenSave = 4294000000;        // (thats close to 80days of runtime...) 
  }
   
  #if FreeMem
  //Free Mem Debug:
  Serial.print("FM ");
  Serial.println( freeMem());  
  #endif
  
  #if RPMDebug
  //Debug RPM generator:
  if(debug>=debugRPM)
  {
     debug = 0;
    digitalWrite(14,HIGH);
    delay(2);
    digitalWrite(14,LOW);
  }
  else
  {
    debug++;
  }
  #endif
    
}



//Bigfont Code
//
//BIG parts from http://opengauge.googlecode.com/svn/trunk/mpguino/mpguino.pde

//-------------------------------------------------------------------------------------------------------
void CGRAM_BigFont2()
{
  
  //255 is the "Full Block" Code, and 254 is blank
  int data1[] = {31,31,31,0,0,0,0,0};    //Small Block on top
  int data2[] = {0,0,0,0,0,31,31,31};    //Small Block on bottom
  int data3[] = {31,31,31,0,0,0,31,31};  //Small Block on top and bottom
 // int data4[] = {28,30,31,31,31,31,30,28};  //Full Block roundet right
 // int data5[] = {7,15,31,31,31,31,15,7};  //Full Block roundet left
  int data6[] = {0,0,0,14,14,14,12,8};  //Dot, for Decimal. 
  
  LcdUploadUdef5x8(1,data1);
  LcdUploadUdef5x8(2,data2);
  LcdUploadUdef5x8(3,data3);
 // LcdUploadUdef5x8(4,data4);
 // LcdUploadUdef5x8(5,data5);
  LcdUploadUdef5x8(6,data6);
    
}
//-------------------------------------------------------------------------------------------------------

void CGRAM_BigFont4()
{
  
  //255 is the "Full Block" Code, and 254 is blank
  int data1[] = {0,0,0,0,3,15,15,31};    //Small Block on bottom left
  int data2[] = {0,0,0,0,31,31,31,31};    //Small Block on bottom right
  int data3[] = {0,0,0,0,24,30,30,31};  //Small Block on bottom full
  int data4[] = {31,15,15,3,0,0,0,0};  //Small Block on top left
  int data5[] = {31,30,30,24,0,0,0,0};  //Small Block on top right
  int data6[] = {31,31,31,31,0,0,0,0};  //Small Block on top full
  int data7[] = {14,14,14,14,12,8,0,0};  //Dot, for Decimal. 
  
  LcdUploadUdef5x8(1,data1);
  LcdUploadUdef5x8(2,data2);
  LcdUploadUdef5x8(3,data3);
  LcdUploadUdef5x8(4,data4);
  LcdUploadUdef5x8(5,data5);
  LcdUploadUdef5x8(6,data6);
  LcdUploadUdef5x8(7,data7);
    
}
//-------------------------------------------------------------------------------------------------------


// Array index into parts of big numbers. Numbers consist of 6 custom characters in 2 lines
//              0             1          2        3          4             5         6       7               8       9    
//char bn12[]={255,1,255,0, 1,255,254,0, 1,3,4,0, 1,3,4,0, 255,2,2,0,     255,3,1,0, 5,3,1,0, 1,1,4,0,       5,3,4,0, 5,3,4,0};
//char bn22[]={255,2,255,0, 2,255,2,0,   5,2,2,0, 2,2,4,0, 254,255,254,0, 2,2,4,0,   5,2,4,0, 254,255,254,0, 5,2,4,0, 254,254,255,0};

char bn12[]={255,1,255,0, 1,255,254,0, 1,3,255,0, 1,3,255,0, 255,2,2,0,     255,3,1,0, 255,3,1,0, 1,1,255,0,       255,3,255,0, 255,3,255,0};
char bn22[]={255,2,255,0, 2,255,2,0,   255,2,2,0, 2,2,255,0, 254,255,254,0, 2,2,255,0,   255,2,255,0, 254,255,254,0, 255,2,255,0, 254,254,255,0};


// Array index into parts of big numbers. Numbers consist of 12 custom characters in 4 lines
//              0               1            2              3                4             5             6              7              8              9    
char bn14[]={1,2,3,0,       2,3,254,0,     1,2,3,0,       1,2,3,0,       2,254,254,0,   2,2,2,0,       1,2,3,0,       2,2,2,0,       1,2,3,0,       1,2,3,0};
char bn24[]={255,254,255,0, 254,255,254,0, 1,2,255,0,     254,2,255,0,   255,2,2,0,     255,2,2,0,     255,2,3,0,     254,2,255,0,   255,2,255,0,   255,254,255,0};
char bn34[]={255,254,255,0, 254,255,254,0, 255,254,254,0, 254,254,255,0, 254,255,254,0, 254,254,255,0, 255,254,255,0, 254,255,254,0, 255,254,255,0, 4,6,255,0};
char bn44[]={4,6,5,0,       6,6,6,0,       4,6,6,0,       4,6,5,0,       254,6,254,0,   6,6,5,0,       4,6,5,0,       254,6,254,0,   4,6,5,0,       254,254,6,0};

//-------------------------------------------------------------------------------------------------------

void printOneNumber2(uint8_t digit, byte leftAdjust, int LineOffset)
{
  // LineOffset = 0, means 1 Line, LineOffset = 20 means 2 Line.
  // leftAdjust = 0, means 1 Pos, leftAdjust = 1 is second Pos.

  // Line 1 of the one digit number
  lcd.commandWrite(0x80+LineOffset+leftAdjust*3+1*leftAdjust);                  //Line1 
  
  lcd.print(bn12[digit*3+digit*1]);
  lcd.print(bn12[digit*3+1+digit*1]);
  lcd.print(bn12[digit*3+2+digit*1]);

  // Line 2 of the one-digit number
  lcd.commandWrite(0xC0+LineOffset+leftAdjust*3+1*leftAdjust);              // Line 2
  lcd.print(bn22[digit*3+digit*1]);
  lcd.print(bn22[digit*3+1+digit*1]);
  lcd.print(bn22[digit*3+2+digit*1]);

}

//-------------------------------------------------------------------------------------------------------

void printOneNumber4(uint8_t digit, byte leftAdjust)
{
  // leftAdjust = 0, means 1 Pos, leftAdjust = 1 is second Pos.

  // Line 1 of the one digit number
  lcd.commandWrite(0x80+leftAdjust*3+1*leftAdjust);                  //Line 1 
  lcd.print(bn14[digit*3]);
  lcd.print(bn14[digit*3+1]);
  lcd.print(bn14[digit*3+2]);

  // Line 2 of the one-digit number
  lcd.commandWrite(0xC0+leftAdjust*3+1*leftAdjust);              // Line 2
  lcd.print(bn24[digit*3]);
  lcd.print(bn24[digit*3+1]);
  lcd.print(bn24[digit*3+2]);

  // Line 3 of the one digit number
  lcd.commandWrite(0x94+leftAdjust*3+1*leftAdjust);                  //Line 3
  lcd.print(bn34[digit*3]);
  lcd.print(bn34[digit*3+1]);
  lcd.print(bn34[digit*3+2]);

  // Line 4 of the one-digit number
  lcd.commandWrite(0xD4+leftAdjust*3+1*leftAdjust);              // Line 4
  lcd.print(bn44[digit*3]);
  lcd.print(bn44[digit*3+1]);
  lcd.print(bn44[digit*3+2]);

}

//-------------------------------------------------------------------------------------------------------

void bigNum (unsigned long t, int LineOffset, byte leftAdjust, int d){     
 
// LineOffset = 0, means 1 Line, LineOffset = 20 means 2 Line.
// d = 0, means no dp!
  
//  unsigned long t = 98550ul;//number in thousandths 
//  unsigned long t = 9855ul;//number in thousandths 
  char  dp = 254; 
  char  dp2 = 254; 
  
 
  char * r = "009.99"; //default to 999
  if(t<=99500){ 
    r=format(t/10); //0098.6 
    dp=6; 
  }else if(t<=999500){ 
    r=format(t/100); 
  }   
  if(t<=9950)
  {
    dp = 254;
    dp2 = 6;
    r=format(t); //009.86
  }
  
  if(d==0)
  {
   dp = 254;
   dp2 = 254;
  }
  
  lcd.commandWrite(0x80+LineOffset+leftAdjust); 
  lcd.printIn(bn12+(r[2]-'0')*4); 
  lcd.printIn(" "); 
  lcd.printIn(bn12+(r[4]-'0')*4); 
  lcd.printIn(" "); 
  lcd.printIn(bn12+(r[5]-'0')*4); 
 
  lcd.commandWrite(0xC0+LineOffset+leftAdjust);
  lcd.printIn(bn22+(r[2]-'0')*4); 
  lcd.print(dp2); 
  lcd.printIn(bn22+(r[4]-'0')*4); 
  lcd.print(dp); 
  lcd.printIn(bn22+(r[5]-'0')*4); 

} 

//-------------------------------------------------------------------------------------------------------

void bigNum4 (unsigned long t, byte leftAdjust, int d){     
 
// LineOffset = 0, means 1 Line, LineOffset = 20 means 2 Line.
// d = 0, means no dp!
  
//  unsigned long t = 98550ul;//number in thousandths 
//  unsigned long t = 9855ul;//number in thousandths 
  char  dp = 254; 
  char  dp2 = 254; 
  
 
  char * r = "009.99"; //default to 999
  if(t<=99500){ 
    r=format(t/10); //0098.6 
    dp=7; 
  }else if(t<=999500){ 
    r=format(t/100); 
  }   
  if(t<=9950)
  {
    dp = 254;
    dp2 = 7;
    r=format(t); //009.86
  }
  
  if(d==0)
  {
   dp = 254;
   dp2 = 254;
  }
  
  lcd.commandWrite(0x80+leftAdjust); 
  lcd.printIn(bn14+(r[2]-'0')*4); 
  lcd.printIn(" "); 
  lcd.printIn(bn14+(r[4]-'0')*4); 
  lcd.printIn(" "); 
  lcd.printIn(bn14+(r[5]-'0')*4); 
 
  lcd.commandWrite(0xC0+leftAdjust); 
  lcd.printIn(bn24+(r[2]-'0')*4); 
  lcd.printIn(" "); 
  lcd.printIn(bn24+(r[4]-'0')*4); 
  lcd.printIn(" "); 
  lcd.printIn(bn24+(r[5]-'0')*4);

  lcd.commandWrite(0x94+leftAdjust); 
  lcd.printIn(bn34+(r[2]-'0')*4); 
  lcd.printIn(" "); 
  lcd.printIn(bn34+(r[4]-'0')*4); 
  lcd.printIn(" "); 
  lcd.printIn(bn34+(r[5]-'0')*4);
 
  lcd.commandWrite(0xD4+leftAdjust);
  lcd.printIn(bn44+(r[2]-'0')*4); 
  lcd.print(dp2); 
  lcd.printIn(bn44+(r[4]-'0')*4); 
  lcd.print(dp); 
  lcd.printIn(bn44+(r[5]-'0')*4); 

} 



//-------------------------------------------------------------------------------------------------------
//Displays a 4 Digit Number (RPM, Thermocouple Temp) over 2 Lines
//only Full Digits are shown!
//no leading 0 or commas.
//it clears all in front

void bigNum24(int Value,int LineOffset)
{
  
  //how many digits?
  
  int Dig;
  
  if(Value>=999)
  {
    Dig = 4;
  }
  else
  {
    if(Value>=99)
    {
      Dig = 3;
    }
    else
    {
      if(Value>=9)
      {
        Dig = 2;
      }
      else
      {
        Dig = 1;
      }
    }
  }
  
  //depending from the Digits, i need to print it different.
  
  int D1;
  int D2;
  int D3;
  int D4; 
    
  switch (Dig) {
    case 1:
      //Thats easy...
      printOneNumber2(Value,0,LineOffset+9);
      
      //And clear digit 1+2+3:
      lcd.commandWrite(0x80+LineOffset+0);                  //Line1 
      blanks3();
      blanks3();
      blanks3();      
      
      lcd.commandWrite(0xC0+LineOffset+0);                  //Line1 
      blanks3();
      blanks3();
      blanks3(); 
      
      break;
    case 2:
      //Not so easy anymore.
      D2 = abs(Value/10);  //First Value
      D1 = Value - D2*10;     //Last Value
      
      printOneNumber2(D2,0,LineOffset+6);
      printOneNumber2(D1,0,LineOffset+9);
      
      //And clear digit 1+2:
      lcd.commandWrite(0x80+LineOffset+0);                  //Line1 
      blanks3();
      blanks3();
      
      
      lcd.commandWrite(0xC0+LineOffset+0);                  //Line1 
      blanks3();
      blanks3();    
      
      break;
    case 3:
      //Not so easy anymore.
      D3 = abs(Value/100);  //First Value
      D2 = abs((Value - D3*100)/10);
      D1 = abs((Value - D3*100 - D2*10));     //Last Value
            
      printOneNumber2(D3,0,LineOffset+3);
      printOneNumber2(D2,0,LineOffset+6);
      printOneNumber2(D1,0,LineOffset+9);
      
      //And clear digit 1:
      lcd.commandWrite(0x80+LineOffset+0);                  //Line1 
      blanks3();
      
      lcd.commandWrite(0xC0+LineOffset+0);                  //Line1 
      blanks3();
      
      
      break;
    case 4:
      //Not so easy anymore.
      D4 = abs(Value/1000); //First Value
      D3 = abs((Value - D4*1000)/100);  
      D2 = abs((Value - D4*1000 - D3*100)/10);
      D1 = abs((Value - D4*1000 - D3*100 - D2*10));     //Last Value
            
      printOneNumber2(D4,0,LineOffset+0);     
      printOneNumber2(D3,0,LineOffset+3);
      printOneNumber2(D2,0,LineOffset+6);
      printOneNumber2(D1,0,LineOffset+9);
    

      break;
    }
  
  
}

void blanks3()
{
      lcd.print(254);
      lcd.print(254);
      lcd.print(254);   
}


//-------------------------------------------------------------------------------------------------------

char fBuff[7];//used by format    

char* format(unsigned long num){
  byte dp = 3;

  while(num > 999999){
    num /= 10;
    dp++;
    if( dp == 5 ) break; // We'll lose the top numbers like an odometer
  }
  if(dp == 5) dp = 99; // We don't need a decimal point here.

// Round off the non-printed value.
  if((num % 10) > 4)
    num += 10;
  num /= 10;
  byte x = 6;
  while(x > 0){
    x--;
    if(x==dp){ //time to poke in the decimal point?{
      fBuff[x]='.';
    }else{
      fBuff[x]= '0' + (num % 10);//poke the ascii character for the digit.
      num /= 10;
    } 
  }
  fBuff[6] = 0;
  return fBuff;
}

/*==============================================================================
 * BUTTON FUNCTIONS                                                                
 *============================================================================*/
 
void ButtonAHold()
{
  
 //This will switch the Screen
   switch(Screen){
   case 0:
      Screen = 1;
      Screen1Init();
      break;
   case 1:
      Screen = 2;
      Screen2Init();
      break;
   case 2:
      Screen = 3;
      Screen3Init();
      break;
   case 3:
      Screen = 4;
      Screen4Init();
      break;
   case 4:
      Screen = 5;
      Screen5Init();
      break;
   case 5:
      Screen = 6;
      Screen6Init();
      break;
   case 6:
      Screen = 7;
      Screen7Init();
      break;      
  case 7:
      Screen = 8;
      Screen8Init();
      break;   
  case 8:
      Screen = 9;
      Screen9Init();
      break;    
  case 9:
      Screen = 0;
      Screen1Init();
      break;    
   default:
      Screen = 0;
      break;
   }
   
  //Set the Timestamp for the Save:
  
  ScreenSave = millis() + ScreenSaveDelay;
   
}

//-------------------------------------------------------------------------------------------------------

void ButtonAPressed()
{
  
  //Serial.print(time*1);
  //Serial.print(";");
  //Serial.println("Button A Pressed");
  
  switch(Screen){
   case 0:
      break;
   case 1:
      ChangeSerOut();      //Switch from RAW to Cal to Nothing and vise versa.
      break;
   case 2:
       //Toggle A and B MCP
      if(val1==8)
      {
        Screen2Init();
      }
      else
      {
        Screen2InitB();
      }
      break; 
   case 3:
      ChangeSerOut();      //Switch from RAW to Cal to Nothing and vise versa.
      break;
   case 6:                 //Switches the 2 Row Screen
	  switch(val1){
	   case 1:
	     val1 = 2;
             Screen6InitB();
	     break;
	   case 2:
	     val1 = 1;
             Screen6Init();
	     break;
	  }
      break;
   case 7:
      RefResh = RefResh + 10;
      if(RefResh>=110)
      {
        RefResh = 0;
      }
      break;
   default:
      break;
  }
 
}

//-------------------------------------------------------------------------------------------------------

void ButtonBHold()
{
 
  //Serial.print(time*1);
  //Serial.print(";");
  //Serial.println("Button B Hold"); 
   
  switch(Screen){
   case 0:
      break;
   case 1:
      //The Calibration from the LD will be done
      CalibrateLD();      
      break;
   default:
   break;
  }
   
}

//-------------------------------------------------------------------------------------------------------

void ButtonBPressed()
{
  
  //Serial.print(time*1);
  //Serial.print(";");
  //Serial.println("Button B Pressed");
 
   switch(Screen){
   case 0:
      break;
   case 1:
      //The MaxLD will be reset!
      MaxLD = 0.0;
      MaxLDt = LDcalPoint;
      break;
   case 2:
      //Change LCD Brightness
      Brightness++;
      if(Brightness>=3)
      {
        Brightness = 0;
      }
      LCDBrightness(Brightness);
      //and save the new value:
      EEPROM.write(105,Brightness); 
      break;
   case 7:
      val4++;      //Change the Scope Screen
      if(val4>=5)
      {
        val4 = 1;
      }
      //Reset the Constrains:
      val1 = 0;
      val2 = 5000;
      break;
   case 8:
      val1++;	//changes the MAX screen through all values
      if(val1>=4)
      {
       val1 = 1;
      }
      break;

   default:
   break;
  }
 
 
}

//-------------------------------------------------------------------------------------------------------

 void ButtonCheck()
 {
	 
	int ButtonState = 0;

	ButtonState = expanderRead();

	/*
	3 = open
	1 = s1
	2 = s2
	*/

        //compensate for the LED:
        ButtonState = ButtonState - 128;

	//now a little inteligent stuff:

	switch(ButtonState) {
	  case 1:
	   if(ButtonTime == 0)
	   {
		 ButtonAPressed();
		 ButtonTime = millis();
	   }
	   else
	   {
		 if(millis()>=ButtonTime+ButtonHold)
		 {
		   ButtonAHold();
		   ButtonTime = millis();
		 }
	   }
	   break;
	   
	  case 2:
	   if(ButtonTime == 0)
	   {
		 ButtonBPressed();
		 ButtonTime = millis();
	   }
	   else
	   {
		 if(millis()>=ButtonTime+ButtonHold)
		 {
		   ButtonBHold();
		   ButtonTime = millis();
		 }
	   }
	   break;
	   
	  case 3:
	   ButtonTime = 0;
	   break;
	  }

	 //Thats it... easy.

 }

/*==============================================================================
 * Other FUNCTIONS                                                                
 *============================================================================*/

//-------------------------------------------------------------------------------------------------------
//http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1239715016/3#3
void printfloat(float all , int decimals){ // will only work with lcd4bit library, basically it breaks the float into 2 integers then prints them seperatley with decimal point in the middle.
int decimal = 1 ;// intial multiplier so you dont get the situation decimal = 0 * 10 arrising
int dec2 = decimals;

while(decimals > 0) // calculate the multipler for moving the decimal along i.e. *10 *100 *1000 etc
   {
  decimal = decimal * 10 ;
  decimals = decimals - 1;
   }

int parta; // the first part of the float (numbers after the decimal point)
int partb; // the last part of the part  (numbers before the decimal point)

parta = int(all); // converting the float into an integer droping the info after the decimal
partb = (all * decimal) - (parta * decimal); // messing around to derive the integer form of the numbers before the decimal
itoa (parta, buf, 10);
lcd.printIn(buf);

lcd.printIn(".");

//if the partb has less then the decimals -1, make a additional 0
if(dec2 ==2)
{
if(partb<10)
{
  lcd.printIn("0");
}
}

itoa (partb, buf, 10);
lcd.printIn(buf);  
}

//-------------------------------------------------------------------------------------------------------
#if InitTime
void lcdShowIntro(int delayValue)
{
  
  //Must load this in 2 steps, somehow its not possible to load 8 chars at once...
  CGRAM_Intro();
  CGRAM_Intro2();

  //Show the Intro: 
  lcd.commandWrite(0x80+2);                  //Line1 
  lcd.print(1);
  lcd.print(2);
  lcd.commandWrite(0x80+10);                  //Line1 
  lcd.print(3);
  lcd.print(4);

  lcd.commandWrite(0xC0+2); 			//Line2
  lcd.print(5);
  lcd.print(6);
  lcd.printIn("ulti");
  lcd.commandWrite(0xC0+10); 			//Line2
  lcd.print(7);
  lcd.print(8);
  lcd.printIn("isplay");
  
  lcd.commandWrite(0xD4+1);                  //Line=4
  lcd.printIn("www.designer2k2.at");
  
  //Set the LCD Brightness: (This turns on the Light, looks nice)
  LCDBrightness(Brightness);
  
  //Flash the Shiftlight:
  
  analogWrite(RPMShiftlightPin,RPMHighBright);
  delay(50);
  analogWrite(RPMShiftlightPin,RPMLowBright);
  delay(50);
  analogWrite(RPMShiftlightPin,RPMNoBright);
  
  
  delay(delayValue);                      //Short delay, for the Intro screen :)
 
}
#endif
//-------------------------------------------------------------------------------------------------------

//http://www.arduino.cc/playground/Code/MCP3208
int read_adc(int channel){
  int adcvalue = 0;
  byte commandbits = B11000000; //command bits - start, mode, chn (3), dont care (3) 
  int Chan = channel;  //Save the channel, to make it possible to deselect the MCP later.
  
  //choose the right MCP3208, depending on number to read.
  if(channel>8)
  {
    //Channels 9-16 on second MCP3208
    IOport2 = IOport2 & B01111101;     //Clears the Selection Pin for MCP 2 (Bitwise AND) (right is the MCP, left the LED)
    //to adapt the right Channel selection
    channel = channel - 8;
  }
  else
  {
    //Channels 1-8 on first MCP3208
    IOport2 = IOport2 & B01111110;     //Clears the Selection Pin for MCP 1 (Bitwise AND) http://www.programmers-corner.com/article/27
  }

  //allow channel selection
  commandbits|=((channel-1)<<3);
  
  expanderWrite2(IOport2); //Select ADC
  
  // setup bits to be written
  for (int i=7; i>=3; i--){
    digitalWriteF(DATAOUT,commandbits&1<<i);
    //cycle clock
    digitalWriteF(SPICLOCK,HIGH);
    digitalWriteF(SPICLOCK,LOW);   
  }

  digitalWriteF(SPICLOCK,HIGH);    //ignores 2 null bits
  digitalWriteF(SPICLOCK,LOW);
  digitalWriteF(SPICLOCK,HIGH); 
  digitalWriteF(SPICLOCK,LOW);

  //read bits from adc
  for (int i=11; i>=0; i--){
    adcvalue+=digitalReadF(DATAIN)<<i;
    //cycle clock
    digitalWriteF(SPICLOCK,HIGH);
    digitalWriteF(SPICLOCK,LOW);
  }
  
    //Deselct the MCP
  if(Chan>8)
  {
    //Channels 9-16 on second MCP3208
    IOport2 = IOport2 | B10000010;     //Sets the Selection Pin for MCP 2    
  }
  else
  {
    //Channels 1-8 on first MCP3208
    IOport2 = IOport2 | B10000001;     //Sets the Selection Pin for MCP 1  
  }
  
  expanderWrite2(IOport2); //Deselect ADC
  
  return adcvalue;
}

//-------------------------------------------------------------------------------------------------------


//http://www.openobject.org/opensourceurbanism/Storing_Data
void EEPROMWriteDouble(int p_address, long p_value)
{
  byte Byte1 = ((p_value >> 0) & 0xFF);
  byte Byte2 = ((p_value >> 8) & 0xFF);
  byte Byte3 = ((p_value >> 16) & 0xFF);
  byte Byte4 = ((p_value >> 24) & 0xFF);

  EEPROM.write(p_address, Byte1);
  EEPROM.write(p_address + 1, Byte2);
  EEPROM.write(p_address + 2, Byte3);
  EEPROM.write(p_address + 3, Byte4);
}
long EEPROMReadDouble(int p_address)
{
  byte Byte1 = EEPROM.read(p_address);
  byte Byte2 = EEPROM.read(p_address + 1);
  byte Byte3 = EEPROM.read(p_address + 2);
  byte Byte4 = EEPROM.read(p_address + 3);

  long firstTwoBytes = ((Byte1 << 0) & 0xFF) + ((Byte2 << 8) & 0xFF00);
  long secondTwoBytes = (((Byte3 << 0) & 0xFF) + ((Byte4 << 8) & 0xFF00));
  secondTwoBytes *= 65536; // multiply by 2 to power 16 - bit shift 24 to the left

  return (firstTwoBytes + secondTwoBytes);
}

//-------------------------------------------------------------------------------------------------------

// Upload a user-defined character (5x8)
// See http://www.quinapalus.com/hd44780udg.html for
// character generator.
// http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1231533425/1#1
void LcdUploadUdef5x8(int character, int *data)
{
  int c = character << 3, i;
  for (i = 0; i < 8; i++)
  {
    lcd.commandWrite(0x40 | c | i);
    lcd.print(data[i]);
  }
}
//-------------------------------------------------------------------------------------------------------

void CGRAM_Dot()
{
   
  int data1[] = {31,0,0,0,0,0,0,31};        //only 2 dots
  int data2[] = {31,0,0,14,0,0,0,31};       //the 2 dots with a minus
  int data3[] = {31,0,4,14,4,0,0,31};       //the 2 dots with a plus
  int data4[] = {31,14,31,31,31,31,14,31};  //thats a block with little rounded edges
  
  LcdUploadUdef5x8(5,data1);
  LcdUploadUdef5x8(6,data2);
  LcdUploadUdef5x8(7,data3);
  LcdUploadUdef5x8(8,data4);
}  
//-------------------------------------------------------------------------------------------------------
  
void CGRAM_Bar()
{
  int data1[] = {16,16,16,16,16,16,16,16};  //1 line
  int data2[] = {24,24,24,24,24,24,24,24};  //2 line
  int data3[] = {28,28,28,28,28,28,28,28};  //3 line
  int data4[] = {30,30,30,30,30,30,30,30};  //4 line
 
  LcdUploadUdef5x8(1,data1);
  LcdUploadUdef5x8(2,data2);
  LcdUploadUdef5x8(3,data3);
  LcdUploadUdef5x8(4,data4);
}
//-------------------------------------------------------------------------------------------------------

void CGRAM_Intro()
{
  int data1[] = {28,28,28,30,30,31,31,31};  // 1--- k
  int data2[] = {7,7,7,15,15,31,31,31};     // -1-- k
  int data3[] = {31,31,31,28,28,28,28,28};  // --1- k
  int data4[] = {24,28,30,15,7,7,7,7};      // ---1 k

  LcdUploadUdef5x8(1,data1);
  LcdUploadUdef5x8(2,data2);
  LcdUploadUdef5x8(3,data3);
  LcdUploadUdef5x8(4,data4); 
}
//-------------------------------------------------------------------------------------------------------

void CGRAM_Intro2()
{
  int data1[] = {31,29,29,28,28,28,28,28};  // 2--- k
  int data2[] = {31,23,23,7,7,7,7,7};       // -2-- k
  int data3[] = {28,28,28,28,28,31,31,31};  // --2- k
  int data4[] = {7,7,7,7,15,30,28,24};      // ---2 k
  
  LcdUploadUdef5x8(5,data1);
  LcdUploadUdef5x8(6,data2);
  LcdUploadUdef5x8(7,data3);
  LcdUploadUdef5x8(8,data4);
}
//-------------------------------------------------------------------------------------------------------

void DrawBar(int Digits, int Value)
{
   
  int Curs = Value/10;
  for (int i=0; i <= Digits-1; i++){
    if(i<Curs)
      {
        lcd.print(255);              
      }
    else
      {
        
        if(i==Curs)
        {
         //in val ist 84 und in val5 die 8
         //ich brauch die 4 /2 als int
         int ChrW = (Value - Curs*10)/2;  
         
         if(ChrW==0)
          {
            lcd.printIn(" "); 
          } 
          else
         {        
           lcd.print(ChrW); 
         }
        }
        else
          {       
            lcd.printIn(" ");
          }
      } 
  }

}

//-------------------------------------------------------------------------------------------------------

void AnaConversion()
{
  //This converts all 16 Analog Values into the real deal :)
 
  //Boost:
  CalRAWBoost = 5.0*AnaIn[BoostPin]/4096.0;             //only gets 0-5V
  CalRAWBoost = (CalRAWBoost * 50 - 10)/100;     	//makes 0-250kPa out of it
  CalBoost = CalRAWBoost - CalLD;			//apply the offset (ambient pressure)
  
 //Check if the Boost is a new Max Boost Event
 if(CalBoost>=MaxLDE[1])
 {
	SaveMax(1);
 }
   
  //Lambda:
  CalLambda = map(AnaIn[LambdaPin], LambdaMin, LambdaMax, 0, 200);    //gets about the 0-1V into 0-200 values
  CalLambda = constrain(CalLambda, 0, 200);

  //CaseTemp: (damped)
  CalCaseTemp = CalCaseTemp*0.9 + (500.0*AnaIn[CaseTempPin]/4096.0)*0.1;  //thats how to get \u00b0C out from a LM35 with 12Bit ADW

  //Throttle:
  CalThrottle = map(AnaIn[ThrottlePin], ThrottleMin, ThrottleMax, 0, 100); 
  CalThrottle = constrain(CalThrottle, 0, 100);
  CalThrottle = 100 - CalThrottle;                 //VR6 has 5V for closed and 0V for open throttle...

  //LMM:
  CalLMM = 5.0*AnaIn[LMMPin]/4096.0;		   //makes 0.0 to 5.0 Volt out of it, with VagCom this could be maped to gr Air i think

  //RPM
  //(from the smoothing example)
  RPMtotal -= RPMreadings[RPMindex];               // subtract the last reading
  RPMreadings[RPMindex] = AnaIn[RPMPin];           // read from the sensor
  RPMtotal += RPMreadings[RPMindex];               // add the reading to the total
  RPMindex = (RPMindex + 1);                       // advance to the next index
  
  if (RPMindex >= RPMsmooth)                       // if we're at the end of the array...
  {
    RPMindex = 0;                                  // ...wrap around to the beginning
  }
  
  RPMaverage = RPMtotal / RPMsmooth;               // calculate the average
  CalRPM = RPMaverage*RPMfactor;                   // apply the factor for calibration
  
 //Check if the RPM is a new Max RPM Event
 if(CalRPM>=MaxRPME[2])
 {
   SaveMax(2);
 }
  
   
   #if RPMShiftLight
   Shiftlight();
   #endif //RPMShiftLight
  
  //Battery Voltage: (Directly from the Arduino!, so only 1024, not 4096.)
  //measured Voltage * 4,09 + 0,7V should give the supply voltage
  BatVolt = ((5.0*analogRead(BatteryPin)/1023.0)*4.09)+0.7;
  
  //Lets do the Typ K Conversion:
  if(DoTypK==1)
  {
   FetchTypK();
  }
  
  //VDO Stuff:
  
  VDOTemp1 = GetVDOTemp(AnaIn[VDOT1Pin]);
  VDOTemp2 = GetVDOTemp(AnaIn[VDOT2Pin]);
  VDOTemp3 = GetVDOTemp(AnaIn[VDOT3Pin]);
  VDOPres1 = GetVDOPressure(AnaIn[VDOP1Pin]);
  VDOPres2 = GetVDOPressure(AnaIn[VDOP2Pin]);
  VDOPres3 = GetVDOPressure(AnaIn[VDOP3Pin]);
  
}
//-------------------------------------------------------------------------------------------------------
#if RPMShiftLight
void Shiftlight()
{
  
  //This sets the brightness according to the RPM
  
  if(CalRPM >= RPMShiftLow && CalRPM <= RPMShiftHigh)
  {
    analogWrite(RPMShiftlightPin,RPMLowBright);
  }
  else if(CalRPM>= RPMShiftHigh)
  {
    analogWrite(RPMShiftlightPin,RPMHighBright);
  }
  else if(CalRPM< RPMShiftLow)
  {
    analogWrite(RPMShiftlightPin,RPMNoBright);
  }
  
}
#endif //RPMShiftLight
//-------------------------------------------------------------------------------------------------------

void SerialPrint()
{  
   switch(SerOut){
    case 0:
     break;
    case 1:
     //RAW Output:
     Serial.print(time);
     Serial.print(";");
     for(int I = 1; I <=15;I++){
        Serial.print(AnaIn[I]);
        Serial.print(";");
     }
     Serial.println(AnaIn[16]);  
     break;
    case 2:
     //Convertet Output:
     Serial.print(time);
     Serial.print(";");
     Serial.print(CalRPM);
     Serial.print(";");
     Serial.print(CalBoost);
     Serial.print(";");
     Serial.print(CalThrottle);
     Serial.print(";");
     Serial.print(CalLambda);
     Serial.print(";");
     Serial.print(CalLMM);
     Serial.print(";");
     Serial.print(CalCaseTemp);
     Serial.print(";");
     Serial.print(CalAGT[0]);
     Serial.print(";");
     Serial.print(CalAGT[1]);
     Serial.print(";");
     Serial.println(BatVolt);
     break;
    default:
     SerOut = 0;
     break; 
  }

}
//-------------------------------------------------------------------------------------------------------

void HeaderPrint()
{

 switch(SerOut){
  case 0:
   //This prints Debugging stuff:
   /*
   Serial.println(" ");
   Serial.print("CalBoost: ");
   Serial.println(CalLD);
   */
   break;
  case 1:
   Serial.println(" ");
   Serial.println("Time;AnaIn0;AnaIn1;AnaIn2;AnaIn3;AnaIn4;AnaIn5;AnaIn6;AnaIn7");
   break;
  case 2:
   Serial.println(" ");
   Serial.println("Time;RPM;Boost;Throttle;Lambda;LMM;CaseTemp;TypK1;TypK2;Battery");
   break;
  default:
   break;  
 }

}
//-------------------------------------------------------------------------------------------------------

void ChangeSerOut()
{
//Switch from RAW to Cal and vise versa.
      switch(SerOut){
        case 0:
         SerOut = 1;
         break;
        case 1:
         SerOut = 2;
         break;
        case 2:
         SerOut = 0;
         break;
        default:
         SerOut = 0;
         break;
        }
       HeaderPrint();
}
//-------------------------------------------------------------------------------------------------------

void CalibrateLD()
{
      CalLD = CalRAWBoost;
      LDcalPoint = val3/10;
      //and saved:
      EEPROM.write(205,LDcalPoint);
      EEPROMWriteDouble(200,CalLD*1000);    //writes the float as long, will do it.

      //The MaxLD will be reset!
      MaxLD = 0.0;
      MaxLDt = LDcalPoint;
      
      Serial.println(" ");
      Serial.print("CalBoost: ");
      Serial.println(CalLD);
}

//-------------------------------------------------------------------------------------------------------

//This converts the thermocouple \u00b5V reading into some usable \u00b0C
int GetTypKTemp(unsigned int microVolts)
{
  int LookedupValue;
  //This searches the 2 surrounding values, and then linear interpolates between them.
  for(int i = 0; i<tempTypKReadings;i++)
  {
   if(microVolts >= pgm_read_word(&tempTypK[i]) && microVolts <= pgm_read_word(&tempTypK[i+1]))
   {
    LookedupValue = ((i)*50) + ((50L *(microVolts - pgm_read_word(&tempTypK[i]))) / ((pgm_read_word(&tempTypK[i+1]) - pgm_read_word(&tempTypK[i]))));
    break;
   }
  }
   
  return LookedupValue;
 }

//Converts the ADW Reading into \u00b0C
int GetVDOTemp(int ADWreading)
{
  int LookedupValue;
  //This searches the 2 surrounding values, and then linear interpolates between them.
  for(int i = 0; i<22;i++)
  {
   if(ADWreading <= pgm_read_word(&tempVDOTemp[i]) && ADWreading >= pgm_read_word(&tempVDOTemp[i+1]))
   {
    LookedupValue = (i*10) + 10 - ((10L *(ADWreading - pgm_read_word(&tempVDOTemp[i+1]))) / ((pgm_read_word(&tempVDOTemp[i]) - pgm_read_word(&tempVDOTemp[i+1]))));
    break;
   }
  }  
 
  LookedupValue -= 30;   //must be reduced as the lookup table starts at -30\u00b0C.
 
  LookedupValue = constrain(LookedupValue,-40,999);    //Limits the Output to 999\u00b0C, so an open circuit gets detectet!
  
  return LookedupValue;
}

//Converts the ADW Reading into 0.1Bar (must be divided by 10 for Bar)
int GetVDOPressure(int ADWreading)
{
  int LookedupValue;
  //This searches the 2 surrounding values, and then linear interpolates between them.
  for(int i = 0; i<12;i++)
  {
   if(ADWreading >= pgm_read_word(&tempVDOPressure[i]) && ADWreading <= pgm_read_word(&tempVDOPressure[i+1]))
   {
    LookedupValue = ((i)*10) + ((10L *(ADWreading - pgm_read_word(&tempVDOPressure[i]))) / ((pgm_read_word(&tempVDOPressure[i+1]) - pgm_read_word(&tempVDOPressure[i]))));
    break;
   }
  }  
  
   LookedupValue -= 10;   //there is an offset of 10 due to my lazy coding

   LookedupValue = constrain(LookedupValue,0,999);    //Limits the Output to 99.9Bars, so an open circuit gets detectet!
 
   return LookedupValue;
}

//-------------------------------------------------------------------------------------------------------


void FetchTypK()
 {
 //This will read in all the needed Analog values, convert them to \u00b0C, and make the calibration with the LM35
 //so it must be called after the AnaConversion! 

//http://www.arduino.cc/playground/Learning/4051
int r0;      //value select pin at the 4051 (s0)
int row;     // storeing the bin code
int  bin [] = {000, 1, 10, 11, 100, 101, 110, 111};//bin = binary, some times it is so easy

 for (int i=0; i <= NumTypK; i++)
 { 

 //there are 8 connections, so i have to set the 3 pins according to all channels

  //This needs to be modded to fit the new IO Handler
  row = bin[i];      
  //r0 = row<<5;   		//Shift them 5 bits so they are 3 MSB (thats where the Selection Pins from the multiplexer are)

  r0 = row<<2;   		//Shift them 2 bits becouse the MSB are the CS from the ADWs, and the next 3 are this ones. the 3 LSB are free but can blink :)
  
    
  //Now i need some bitmath to get the bits set in r0 into the IOport2 byte.
  
  //First we clear this 3 spots
  
  byte Mask = B11100011;
  
  IOport2 = IOport2 & Mask;
  
  //Now we set the apropiate Bits:
  
  IOport2 = IOport2 | r0;
  
  //And write it to the Chip:
  
  expanderWrite2(IOport2);    //writes it to the port
    
  delay(20);   //Due to the 0.1 \u00b5F cap this is needed. The Cap should be there to get a stable reading! (from open to RT it takes 15ms, plus 5ms safety)
   
 //then read in the value from the ADW

   Temp = ((5.0*read_adc(AGTPin))/4096.0)*10000;   //gets the Volts and makes \u00b5V out of it (100 is already added from the Amp)
   Temp = GetTypKTemp(Temp);                       //Converts the \u00b5V into \u00b0C 
   
 //Check if it is open:
 
   if(Temp>=MaxTypK)
    {
     Temp = 0; 
    }
   else
    { 
     Temp += int(CalCaseTemp);                       //apply the Correction
    }
  
   CalAGT[i] = Temp;              //Save it into the array
 
    //Check if the Temp is a new Max Temp Event
    if(Temp>=MaxAGTValE[3])
    {
      SaveMax(3);
    }
 
 //repeat for all NumTypK+1 channels.
 }

}
 
//-------------------------------------------------------------------------------------------------------

 
void CGRAM_VertBar()
{
   
  int data1[] = {0,0,0,0,0,0,0,31};              //1 row
  int data2[] = {0,0,0,0,0,0,31,31};             //2 rows
  int data3[] = {0,0,0,0,0,31,31,31};            //3 rows
  int data4[] = {0,0,0,0,31,31,31,31};           //4 rows
  int data5[] = {0,0,0,31,31,31,31,31};          //5 rows
  int data6[] = {0,0,31,31,31,31,31,31};         //6 rows
  int data7[] = {0,31,31,31,31,31,31,31};        //7 rows
  
  LcdUploadUdef5x8(1,data1);
  LcdUploadUdef5x8(2,data2);
  LcdUploadUdef5x8(3,data3);
  LcdUploadUdef5x8(4,data4);
  LcdUploadUdef5x8(5,data5);
  LcdUploadUdef5x8(6,data6);
  LcdUploadUdef5x8(7,data7);
  
} 
  //-------------------------------------------------------------------------------------------------------

void DrawVertBar(int Val, int Pos)
{
//Val must be between 0 and 32 (4x8)
//Pos must be between 0 and 20 (on a 20 char disp)

//whats the modulo with 8 ?
int Mod;
Mod = Val % 8;
//This is directly the code for the top character!
//But at what pos it must be printed?

int PrintPos;
PrintPos = (Val - Mod) / 8;

//But if Mod = 0, the LCD nothing is 254.

if(Mod == 0)
 Mod=254;

//now lets make a switch case depending on the PrintPos.

switch(PrintPos){
  case 0:
    //so there is only one character /3 blanks and the character in the lowest position
    lcd.commandWrite(0x80+Pos);              //Line 1 
    lcd.print(254); //Blank
    lcd.commandWrite(0xC0+Pos);              //Line 2
    lcd.print(254); //Blank
    lcd.commandWrite(0x94+Pos);              //Line 3
    lcd.print(254); //Blank
    lcd.commandWrite(0xD4+Pos);              //Line 4
    lcd.print(Mod); //The Custom Character presenting the value
    break;
  case 1:
    //so there is only one character /1 fulls and the character in the 2nd position
    lcd.commandWrite(0x80+Pos);              //Line 1 
    lcd.print(254); //Blank
    lcd.commandWrite(0xC0+Pos);              //Line 2
    lcd.print(254); //Blank
    lcd.commandWrite(0x94+Pos);              //Line 3
    lcd.print(Mod); //The Custom Character presenting the value
    lcd.commandWrite(0xD4+Pos);              //Line 4
    lcd.print(255); //Full
    break;
  case 2:
    //so there is only one character /2 fulls and the character in the 3rd position
    lcd.commandWrite(0x80+Pos);              //Line 1 
    lcd.print(254); //Blank
    lcd.commandWrite(0xC0+Pos);              //Line 2
    lcd.print(Mod); //The Custom Character presenting the value
    lcd.commandWrite(0x94+Pos);              //Line 3
    lcd.print(255); //Full
    lcd.commandWrite(0xD4+Pos);              //Line 4
    lcd.print(255); //Full
    break;
  case 3:
    //so there is only one character /3 fulls and the character in the highest position
    lcd.commandWrite(0x80+Pos);              //Line 1 
    lcd.print(Mod); //The Custom Character presenting the value
    lcd.commandWrite(0xC0+Pos);              //Line 2
    lcd.print(255); //Full
    lcd.commandWrite(0x94+Pos);              //Line 3
    lcd.print(255); //Full
    lcd.commandWrite(0xD4+Pos);              //Line 4
    lcd.print(255); //Full
    break;
  case 4:
    //easy, eveything is full!
    lcd.commandWrite(0x80+Pos);              //Line 1 
    lcd.print(255); //Full
    lcd.commandWrite(0xC0+Pos);              //Line 2
    lcd.print(255); //Full
    lcd.commandWrite(0x94+Pos);              //Line 3
    lcd.print(255); //Full
    lcd.commandWrite(0xD4+Pos);              //Line 4
    lcd.print(255); //Full
    break;
}

 //thats it, easy :) 
    
}

 //-------------------------------------------------------------------------------------------------------

void ScopeMode()
{
  
   //but work the screen from left side
  for(int i=0; i<=18; i++){
    
   //Print the Buffer    
   DrawVertBar(ScopeInt[i],i);
    
   //shift Data to the left    
   ScopeInt[i] = ScopeInt[i+1];
    
  } 
  
}


//Free Mem: http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1246358387
#include <stdlib.h>
#include <inttypes.h>
#include <avr/io.h>

extern char * const __brkval;

uint16_t freeMem(void)
{
  char *brkval;
  char *cp;

  brkval = __brkval;
  if (brkval == 0) {
    brkval = __malloc_heap_start;
  }
  cp = __malloc_heap_end;
  if (cp == 0) {
    cp = ((char *)AVR_STACK_POINTER_REG) - __malloc_margin;
  }
  if (cp <= brkval) return 0;

  return cp - brkval;
}
 
//----------------------------------------------------------------------------------------------------
//This checks certain values if they exceed limits or not, if so an alarm is triggered
void CheckLimits()
{

  int FlashTrigger=0;
  
  /*
  if(VDOPres1>MaxOP)
  {
    FlashTrigger = 1;    //Enable the LCDFlash
  }
  */  
  
  if(CalAGT[0]>MaxAGT)
  {
    FlashTrigger = 1;    //Enable the LCDFlash
  }
  
  
  if(CalAGT[1]>MaxAGT)
  {
    FlashTrigger = 1;    //Enable the LCDFlash
  }

   
  //Set The new Flash Timeout 
  if(FlashTrigger>0)
  {
    FlashETimeU = millis() + FlashETime;
    FlashTrigger = 0;
  }

  
  //And Flash!      
  if(FlashETimeU>=millis())                     //Check if the Flash should be shown
    {
      if(FlashTimeU<=millis())                  //Check if the Flash is about to be changed
      {
        //Now lets change the Brightness
        if(Brightness>0)
        {
          Brightness = 0;
        }
        else
        {
          Brightness = 2;
        }
               
        FlashTimeU = millis() + FlashTime;      //And save the Next Changetime
        LCDBrightness(Brightness);              //And set the Brightness
      }     
    }
    else
    {
       Brightness = EEPROM.read(105);           //Set back the Brightness
       LCDBrightness(Brightness);              //And set the Brightness
    }
     
}

//----------------------------------------------------------------------------------------------------
//http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1173047782/5
void expanderWrite(byte _data) {
  Wire.beginTransmission(expander);
  Wire.send(_data);
  Wire.endTransmission();
}

byte expanderRead() {
  byte _data;
  Wire.requestFrom(expander, 1);
  if(Wire.available()) {
    _data = Wire.receive();
  }
  return _data;
}

void expanderWrite2(byte _data) {
  Wire.beginTransmission(expander2);
  Wire.send(_data);
  Wire.endTransmission();
}

byte expanderRead2() {
  byte _data;
  Wire.requestFrom(expander2, 1);
  if(Wire.available()) {
    _data = Wire.receive();
  }
  return _data;
}

//----------------------------------------------------------------------------------------------------
//Saves all Data to the arrays
  void SaveMax(int Num)
  {
   MaxAGTValE[Num] = CalAGT[0];  
   MaxLDE[Num] = CalBoost; 
   MaxRPME[Num] = CalRPM; 
   MaxLMME[Num] = CalLMM;
   MaxOilE[Num] = VDOPres1;
  }
  
void LCDBrightness(int Bright)
{
analogWrite(LCDBrightPin,pgm_read_word(&LCDBrightnessD[Bright]));
}
  

//Main Screen

void Screen1Init()
{
  
  lcd.init();
  
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("EGT:");

  lcd.commandWrite(0x94);                  //Line=3
  lcd.printIn("LD:        Max:");

  //Load the specific data:
  CGRAM_Bar();
  CGRAM_Dot();
  
  //Lets to the Conversion:
  DoCal = 1;
  
  //Fetch Typ K
  DoTypK = 1;

  //Select Serial Out Mode "Convertet":
  SerOut = 2;

  //print the Serial Header:
  HeaderPrint();
  
}

void Screen1Work()
{
 
  //Calibrate it:
  val = CalLambda/10;
  val3 = map(AnaIn[BoostPin], 0, 4096, 0, 200);
  //val3 = constrain(val3, 0, 200);
  
  lcd.commandWrite(0x80+5);               //Line 1, position 5! 

  lcd.printIn(itoa((CalAGT[0]+CalAGT[1])/2, buf, 10));  //AGT1+AGT2/2 thats becouse off my 2 Probes
  
  lcd.print(32);                           //Print a " " at the end, to clear in case its needed
 
 
  lcd.commandWrite(0x80+14);              //Line 3, 
    
  printfloat(CalCaseTemp,1);
  
  lcd.print(223);                         //Print a " " at the end, to clear in case its needed 
  lcd.printIn("C");                       //Print a " " at the end, to clear in case its needed
  
  lcd.commandWrite(0x94+3); 
  if(CalBoost<0.0)
    {
      lcd.printIn("-");
    }
  else
    {
      lcd.printIn(" ");
    } 
  printfloat(abs(CalBoost),2);              //Shows current Boost
  
  //Check for new MaxLD, and then save the point where to make the square
  if(CalBoost>MaxLD)
  {
    MaxLD  = CalBoost;
    MaxLDt = val3/10;
  }
  
  lcd.commandWrite(0x94+16); 
  printfloat(MaxLD,2);                    //Max Boost
  
  //Lets draw the dot:
    lcd.commandWrite(0xC0);              // Line 2
    for (int i=0; i <= 19; i++){
    if(i==val)
      {
        lcd.print(8);        //thats the Dot 
      }
    else
      {
        if(i <= LambdaLowerLimit)    //from 0-4 a minus then nothing
        {
          lcd.print(6);
        }
        else
        {
          if(i <= LambdaUpperLimit) //from 5-15 ist nothing and then a plus
          {
           lcd.print(5);
          }
         else
         {
           lcd.print(7);
         }
        }
      }
  }

  //Now lets make the Bar:
  lcd.commandWrite(0xD4);                // Line 4
  DrawBar(20,val3);
  
  //And draw a Dot at the max pos & 0 Pos
  
  lcd.commandWrite(0xD4+MaxLDt);                // Line 4
  lcd.print(255);  
  
  lcd.commandWrite(0xD4+LDcalPoint);                // Line 4
  lcd.print(255);  
  
  
}

//Debug Screen

void Screen2Init()
{
  
  lcd.init();
  
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("A1:       A2:");
  lcd.commandWrite(0xC0);                  //Line=2
  lcd.printIn("A3:       A4:");
  lcd.commandWrite(0x94);                  //Line=3
  lcd.printIn("A5:       A6:");
  lcd.commandWrite(0xD4);                  //Line=4
  lcd.printIn("A7:       A8:");
  
  RefResh = 2;
  val = 2;  
  
  //Select Serial Out Mode RAW:
  SerOut = 1;

  //And calibration:
  DoCal = 1;
  
  //Fetch Typ K
  DoTypK = 1;
  
  //print the Serial Header:
  HeaderPrint();
  
  
  //select A (0 Offset)
  val1 = 0;

}

void Screen2InitB()
{
  
  lcd.init();
  
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("B1:       B2:");
  lcd.commandWrite(0xC0);                  //Line=2
  lcd.printIn("B3:       B4:");
  lcd.commandWrite(0x94);                  //Line=3
  lcd.printIn("B5:       B6:");
  lcd.commandWrite(0xD4);                  //Line=4
  lcd.printIn("B7:       B8:");
  
  RefResh = 2;
  val = 2;  
  
  //print the Serial Header:
  HeaderPrint();

  //select B (8 Offset)
  val1 = 8;

}


void Print2Blanks()
{
  lcd.print(32);
  lcd.print(32);
}

void Screen2Work()
{
  //This screen only shows the current Value from all 8 Inputs in RAW
  //and only after every X refreshes, so its faster on the serial & its easier to read

  if(val>=RefResh)
  {
     val = 0;
    
    lcd.commandWrite(0x80+4);                  //A1
    lcd.printIn(itoa((AnaIn[1+val1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0x80+14);                 //A2
    lcd.printIn(itoa((AnaIn[2+val1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xC0+4);                  //A3
    lcd.printIn(itoa((AnaIn[3+val1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xC0+14);                 //A4
    lcd.printIn(itoa((AnaIn[4+val1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0x94+4);                  //A5
    lcd.printIn(itoa((AnaIn[5+val1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0x94+14);                 //A6
    lcd.printIn(itoa((AnaIn[6+val1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xD4+4);                  //A7
    lcd.printIn(itoa((AnaIn[7+val1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xD4+14);                 //A8
    lcd.printIn(itoa((AnaIn[8+val1]), buf, 10));
    Print2Blanks();
  }
  else
  {
    val++;
  }
  
}

//Bar Screen

void Screen3Init()
{
  
  lcd.init();
  
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("LAM:");
  lcd.commandWrite(0xC0);                  //Line=2
  lcd.printIn("LD :");
  lcd.commandWrite(0x94);                  //Line=3
  lcd.printIn("THR:");
  lcd.commandWrite(0xD4);                  //Line=4
  lcd.printIn("RPM:");
  
  CGRAM_Bar();

  //Select Serial Out Mode Converted:
  SerOut = 2;

  //And calibration:
  DoCal = 1;  
  
  //Fetch Typ K
  DoTypK = 1;

  //print the Serial Header:
  HeaderPrint();
  
  
  RefResh = 10;
  val = 50; 

}

void Screen3Work()
{ 
  
  //First, show the Bars on the last 10 Chars:
  
  val1 = map(AnaIn[BoostPin], 0, 4096, 0, 100);
  val1 = constrain(val1, 0, 100);
  val2 = map(AnaIn[RPMPin], 0, RPMmax, 0, 100);
  val2 = constrain(val2, 0, 100);
  
  //Print the Values:
  

  lcd.commandWrite(0x80+5);       
  lcd.printIn(itoa(CalLambda, buf, 10));
  lcd.print(32);
  lcd.commandWrite(0xC0+4);    

  if(CalBoost<0.0)
    {
      lcd.printIn("-");
    }
  else
    {
      lcd.printIn(" ");
    } 
  printfloat(abs(CalBoost),2);              //Shows current Boost
  
  lcd.print(32);
  lcd.commandWrite(0x94+5);               
  lcd.printIn(itoa(CalThrottle, buf, 10));
  lcd.print(32);
  lcd.commandWrite(0xD4+5);               
  lcd.printIn(itoa((CalRPM/10)*10, buf, 10));    //gets rid of the last 10, thats not needed.
  lcd.print(32);
  
  
   //Now lets make the Bars:
  lcd.commandWrite(0x80+10);               
  DrawBar(10,CalLambda/2);
  lcd.commandWrite(0xC0+10);               
  DrawBar(10,val1);
  lcd.commandWrite(0x94+10);               
  DrawBar(10,CalThrottle);
  lcd.commandWrite(0xD4+10);               
  DrawBar(10,val2);
  
}

//Typ K Screen
void Screen4Init()
{
   lcd.init();
   
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("T1:       T2:");
  lcd.commandWrite(0xC0);                  //Line=2
  lcd.printIn("T3:       T4:");
  lcd.commandWrite(0x94);                  //Line=3
  lcd.printIn("T5:       T6:");
  lcd.commandWrite(0xD4);                  //Line=4
  lcd.printIn("T7:       T8:");

  RefResh = 2;
  val = 2;  
  
  //Lets to the Conversion:
  DoCal = 1;
  
  //Fetch Typ K
  DoTypK = 1;

  //Select Serial Out Mode "Convertet":
  SerOut = 2;
  
  //print the Serial Header:
  HeaderPrint();

}

void Screen4Work()
{ 
   
  //This just print\u00b4s all the Thermocouple values:
  //like screen2 it only updates every X repeat\u00b4s
  
  
  
    if(val>=RefResh)
  {
     val = 0;
    
    lcd.commandWrite(0x80+4);                  //T1
    lcd.printIn(itoa((CalAGT[0]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0x80+14);                 //T2
    lcd.printIn(itoa((CalAGT[1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xC0+4);                  //T3
    lcd.printIn(itoa((CalAGT[2]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xC0+14);                 //T4
    lcd.printIn(itoa((CalAGT[3]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0x94+4);                  //T5
    lcd.printIn(itoa((CalAGT[4]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0x94+14);                 //T6
    lcd.printIn(itoa((CalAGT[5]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xD4+4);                  //T7
    lcd.printIn(itoa((CalAGT[6]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xD4+14);                 //T8
    lcd.printIn(itoa((CalAGT[7]), buf, 10));
    Print2Blanks();
    
  }
  else
  {
    val++;
  }
  
  
  //delay(50);
  
}

//1 Row Big Font Screen

void Screen5Init()
{
  
  lcd.init();
  
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("Boost:");

  lcd.commandWrite(0x94);                  //Line2
  lcd.printIn("Max:");
 
  //Load the specific data:
  CGRAM_BigFont4();
  
  //Lets to the Conversion:
  DoCal = 1;
  
  //Fetch Typ K
  DoTypK = 1;

  //Select Serial Out Mode "Convertet":
  SerOut = 2;

  //print the Serial Header:
  HeaderPrint();
  
  RefResh = 10;
  val = 10;  
  
}

void Screen5Work()
{
   
    //and only after every X refreshes, so its faster on the serial & its easier to read

  if(val>=RefResh)
  {
     val = 0;

  
  lcd.commandWrite(0xC0+7); 
  if(CalBoost<0.0)
    {
      lcd.print(2);
      lcd.print(2);
    }
  else
    {
      lcd.printIn("  ");
    } 

  //bigNum(abs(CalBoost)*1000,0,9,1);
  
  bigNum4(abs(CalBoost)*1000,9,1);
  
  }
  else
  {
    val++;
  }
    
  //Check for new MaxLD
  if(CalBoost>MaxLD)
  {
    MaxLD  = CalBoost;
  }
  
  
  lcd.commandWrite(0xD4); 
  printfloat(MaxLD,2);                    //Max Boost
  
  
  
}

//2 Row Big Font Screen

void Screen6Init()
{
  
  lcd.init();
  
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("Boost:");

  lcd.commandWrite(0x94);                  //Line3
  lcd.printIn("Temp:");
 
  //Load the specific data:
  CGRAM_BigFont2();
  
  //Lets to the Conversion:
  DoCal = 1;
  
  //Fetch Typ K
  DoTypK = 1;

  //Select Serial Out Mode "Convertet":
  SerOut = 2;

  //print the Serial Header:
  HeaderPrint();
  
  RefResh = 5;
  val = 10;    
  val1 = 1;
  
}

void Screen6InitB()
{
  
  lcd.init();
  
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("T1:   ");

  lcd.commandWrite(0x94);                  //Line3
  lcd.printIn("T2:   ");
 
   //Clear the - from the screen A
  lcd.commandWrite(0x80+7); 
  lcd.printIn("  "); 	  
 
  //Load the specific data:
  CGRAM_BigFont2();
  
  //print the Serial Header:
  HeaderPrint();
  
  RefResh = 5;
  val = 10;    
  
}

void Screen6Work()
{
   
   //and only after every X refreshes, so its faster on the serial & its easier to read
 
   if(val>=RefResh)
  {
     val = 0;
  
 
  switch(val1){
   case 1:
     
	  //The Boost:
	  
	  lcd.commandWrite(0x80+7); 
	  if(CalBoost<0.0)
		{
		  lcd.print(2);
		  lcd.print(2);
		 }
	  else
		{
		  lcd.printIn("  ");
		} 

	  bigNum(abs(CalBoost)*1000,0,9,1);
	   
		
	  //The Temp:
	 
	 
	  bigNum(abs(CalCaseTemp)*1000,20,9,1);
	   
  
  break;
  case 2:
     //T1:
  
     bigNum24(CalAGT[0],0+8);
   
     //T2:
 
     //bigNum24(CalAGT[1],20);
     
     bigNum24(CalAGT[1],20+8);
  
     break;
 case 3:
  val1 = 1;
  break;
  }
  
  
      }
  else
  {
    val++;
  }
  
  
  
}

//Scope Mode Screen

void Screen7Init()
{
  
  lcd.init();
  
  //Load the specific data:
  CGRAM_VertBar();
  
  //Lets not to the Conversion:
  DoCal = 0;
  
  //Fetch Typ K
  DoTypK = 0;

  //Select Serial Out Mode "Nothing":
  SerOut = 0;

  //print the Serial Header:
  HeaderPrint();
  
  //The Constrains:
  val1 = 0;
  val2 = 5000;
  
  //The Data Selector
  val4 = 1; 
  
  RefResh = 10;
  val = 10;   
  
}


void Screen7Work()
{
   
  //new Constrains if needed
  
  int ScopeVal;
  
  
  
  switch(val4){
    case 1:
     ScopeVal = AnaIn[BoostPin];
     break;
    case 2:
     ScopeVal = CalThrottle;
     break;
    case 3:
     ScopeVal = CalLMM;
     break;
    case 4:
     ScopeVal = CalRPM;
     break;
    default:
     break;
    }
  
  
  if(ScopeVal<val2)
  {
     val2 = ScopeVal;
  }
  
  if(ScopeVal>val1)
  {
    val1 = ScopeVal;
  }
  
  //Get the Data:  
  val3 = map(ScopeVal, val2, val1, 0, 33);
  //val3 = constrain(val3, 0, 32);
     
  //Show only the rightmost bar: (live screen)
  DrawVertBar(val3,19);
  
 //and show it only after every X refreshes, so its faster on the serial & its easier to read
 if(val>=RefResh)
  {
     val = 0;
    
     //Feed it into the Buffer (on the right side)
     ScopeInt[19] = val3;
    
     ScopeMode();
     
  }
  else
  {
    val++;
  }


  //Draw the Caption:  
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn(itoa(val4, buf, 10));
  lcd.printIn(":");
  lcd.printIn(itoa(RefResh, buf, 10));  

  
  Serial.println(time);
 
}

//Max Value Screen (This shows the Max LD, RPM or AGT or Oil values)
void Screen8Init()
{
   lcd.init();
   
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("Max ");
  lcd.commandWrite(0xC0);                  //Line=2
  lcd.printIn("LD:       RPM:");
  lcd.commandWrite(0x94);                  //Line=3
  lcd.printIn("LMM:      AGT:");
  //lcd.commandWrite(0xD4);                  //Line=4
  //lcd.printIn("T7:       T8:");

  RefResh = 2;
  val = 2;  
  
  //Selects the first MAX Screen
  val1 = 1;
  
  //Lets to the Conversion:
  DoCal = 1;
  
  //Fetch Typ K
  DoTypK = 1;

  //Select Serial Out Mode "Convertet":
  SerOut = 2;
	
  //print the Serial Header:
  HeaderPrint();

}

void Screen8Work()
{ 
   
  //like screen2 it only updates every X repeat\u00b4s
  
    if(val>=RefResh)
  {
     val = 0;
    
    //lcd.commandWrite(0x80+4);                  //T1
    //Print2Blanks();
    //lcd.commandWrite(0x80+14);                 //T2
    //lcd.printIn(itoa((CalAGT[1]), buf, 10));
    //Print2Blanks();
	
	//Header:
	lcd.commandWrite(0x80+4);                  //Line
	lcd.printIn(itoa(val1, buf, 10));
	
	
    lcd.commandWrite(0xC0+3);                  //Max1LD
    
      if(MaxLDE[val1]<0.0)
    {
      lcd.printIn("-");
    }
  else
    {
      lcd.printIn(" ");
    } 
  printfloat(abs(MaxLDE[val1]),2);              //Shows current Boost
  
    
    
    //lcd.printIn(itoa((CalAGT[2]), buf, 10));
    //Print2Blanks();
    lcd.commandWrite(0xC0+14);                 //Max1RPM
    lcd.printIn(itoa(MaxRPME[val1], buf, 10));
    Print2Blanks();
    lcd.commandWrite(0x94+4);                  //LMM
    lcd.printIn(itoa((MaxLMME[val1]), buf, 10));
    Print2Blanks();
    lcd.commandWrite(0x94+14);                 //Max1AGTVal
    lcd.printIn(itoa(MaxAGTValE[val1], buf, 10));
    Print2Blanks();
    //lcd.commandWrite(0xD4+4);                  //T7
    //lcd.printIn(itoa((CalAGT[6]), buf, 10));
    //Print2Blanks();
    //lcd.commandWrite(0xD4+14);                 //T8
    //lcd.printIn(itoa((CalAGT[7]), buf, 10));
    //Print2Blanks();
    
  }
  else
  {
    val++;
  }
  
  
  //delay(50);
  
}

//VDO Screen

void Screen9Init()
{
   lcd.init();
   
  lcd.commandWrite(0x80);                  //Line1
  lcd.printIn("VDO Screen:");
  lcd.commandWrite(0xC0);                  //Line=2
  lcd.printIn("T1:       P1:");
  lcd.commandWrite(0x94);                  //Line=3
  lcd.printIn("T2:       P2:");
  lcd.commandWrite(0xD4);                  //Line=4
  lcd.printIn("T3:       P3:");

  RefResh = 5;
  val = 2;  
  
  //Lets to the Conversion:
  DoCal = 1;
  
  //Fetch Typ K
  DoTypK = 1;

  //Select Serial Out Mode "Convertet":
  SerOut = 2;
  
  //print the Serial Header:
  HeaderPrint();

}

void Screen9Work()
{ 
   
  //This just print\u00b4s all the Thermocouple values:
  //like screen2 it only updates every X repeat\u00b4s
  
  
  
    if(val>=RefResh)
  {
     val = 0;
    
    lcd.commandWrite(0xC0+4);                  //T1
    lcd.printIn(itoa(VDOTemp1, buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xC0+14);                 //P1
    printfloat(float(VDOPres1/10.0),1);
    Print2Blanks();
    lcd.commandWrite(0x94+4);                  //T2
    lcd.printIn(itoa(VDOTemp2, buf, 10));  
    Print2Blanks();
    lcd.commandWrite(0x94+14);                 //P2
    printfloat(float(VDOPres2/10.0),1);
    Print2Blanks();
    lcd.commandWrite(0xD4+4);                  //T3
    lcd.printIn(itoa(VDOTemp3, buf, 10));
    Print2Blanks();
    lcd.commandWrite(0xD4+14);                 //P3
    printfloat(float(VDOPres3/10.0),1);
    Print2Blanks();
        
  }
  else
  {
    val++;
  }
  
  //delay(50);
  
}


int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

